﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Interactivity;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;
using Infragistics.Windows;

namespace Demo
{
    public class ButtonBehavior : Behavior<Button>
    {

        private Button AssociatedButton
        {
            get { return AssociatedObject as Button; }
        }

        public static readonly DependencyProperty ParentDGProperty =
                               DependencyProperty.Register("ParentDG",typeof(XamDataGrid),typeof(ButtonBehavior),new FrameworkPropertyMetadata(null));

        public XamDataGrid ParentDG
        {
            get { return (XamDataGrid)GetValue(ParentDGProperty); }
            set { SetValue(ParentDGProperty, value); }
        }


        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.Loaded += AssociatedObject_Loaded;
            AssociatedButton.MouseLeftButtonUp += AssociatedButtonMouseLeftButtonUp;            
        }

        private void AssociatedObject_Loaded(object sender, RoutedEventArgs e)
        {
            var t = Utilities.GetAncestorFromType(AssociatedObject as DependencyObject, typeof(XamDataGrid), false);
            if (t != null)
            {
                this.ParentDG = (XamDataGrid)t;
                ParentDG.RecordFilterChanged += ParentDGRecordFilterChanged;
            }
        }

        private void AssociatedButtonMouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            //To Do
        }

        private void ParentDGRecordFilterChanged(object sender, RecordFilterChangedEventArgs e)
        {
            //To Do
        }

     
    }
}
